#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <pthread.h>

#define MAXBUF  256

void *do_thread(void *arg);

int main()
{
    int ssock, csock;
    int clen;
    struct sockaddr_in client_addr, server_addr;
    pthread_t tid;

    /*   */
    if ((ssock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        perror("socket error : ");
        exit(1);
    }

    /*  ɼ  */
    clen = sizeof(client_addr);

    memset(&server_addr, 0, sizeof(server_addr));
    server_addr.sin_family     = AF_INET;
    server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    server_addr.sin_port     = htons(3317);


    /*  ɼ  */
    if (bind(ssock, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0)
    {
        perror("bind error : ");
        exit(1);
    }
    
    /*    */
    if (listen(ssock, 5) < 0) {
        perror("listen error : ");
        exit(1);
    }

    while(1) {
        /*  ó */
        csock = accept(ssock, (struct sockaddr *)&client_addr, &clen);

        /* pthread_create() ̿Ͽ multi-thread   ó */
        if (pthread_create(&tid, NULL, do_thread, (void *)csock) < 0)
        {
            perror("thread create error : ");
            exit(1);
        }
    }

    return 0;
}

void *do_thread(void *arg) 
{
    /*  Ŭ̾Ʈ  ó */
    int csock;
    pthread_t tid;
    char buf[MAXBUF];

    tid = pthread_self();
    printf("ο  0x%x Ǿϴ\n", tid);
    
    csock = (int)arg;
    while(read(csock, buf, MAXBUF) > 0)
    {
        if (write(csock, buf, MAXBUF) <=0) {
            perror("write error : ");
            exit(1);
        }
    }

    close(csock);
    
    printf("0x%x 尡 Ǿϴ\n", tid);

    pthread_exit(NULL);
}

