// DlgChattingRoom.cpp : implementation file
//

#include "stdafx.h"
#include "ChatClient.h"
#include "ChatClientDlg.h"
#include "DlgChattingRoom.h"
#include "packetCode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgChattingRoom dialog


CDlgChattingRoom::CDlgChattingRoom(int _roomNum,CString name,CWnd* pParent /*=NULL*/)
	: CDialog(CDlgChattingRoom::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgChattingRoom)
	m_inputText = _T("");
	//}}AFX_DATA_INIT
	parentWnd=pParent;
	roomNum=_roomNum;
	strRoomNum.Format("%d",_roomNum);
	userName=name;
}


void CDlgChattingRoom::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgChattingRoom)
	DDX_Control(pDX, IDC_ROOM_USER_LIST, m_roomUserList);
	DDX_Control(pDX, IDC_CHATMSG, m_chatMsg);
	DDX_Text(pDX, IDC_INPUT, m_inputText);
	DDV_MaxChars(pDX, m_inputText, 200);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgChattingRoom, CDialog)
	//{{AFX_MSG_MAP(CDlgChattingRoom)
	ON_BN_CLICKED(IDC_SEND_MSG, OnSendMsg)
	ON_BN_CLICKED(IDC_QUIT_CHATTING_ROOM, OnQuitChattingRoom)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgChattingRoom message handlers

BOOL CDlgChattingRoom::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//ȭ ( ) ûѴ.
	((CChatClientDlg *)parentWnd)->m_pClientSock->sendPacket(C2S_REQ_ROOM_DATA,strRoomNum);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgChattingRoom::insertUser(char *pName)
{
	m_roomUserList.AddString(pName);
}

void CDlgChattingRoom::CloseWnd()
{
	CDialog::OnCancel();
}

void CDlgChattingRoom::OnSendMsg() 
{
	CString sendBuf;

	UpdateData(TRUE);
	sendBuf.Format("%s : %s\r\n",userName,m_inputText);

	insertMsg(sendBuf);
	((CChatClientDlg *)parentWnd)->m_pClientSock->sendPacket(C2S_SND_CHAT_MSG,sendBuf);	

	m_inputText="";
	UpdateData(FALSE);
}

void CDlgChattingRoom::insertMsg(CString msg)
{
	m_chatMsg.ReplaceSel(msg);
	m_chatMsg.LineScroll(m_chatMsg.GetLineCount());
}

void CDlgChattingRoom::delUser(char* delUser)
{
	int nIndex=0;
	if((nIndex=m_roomUserList.FindString(nIndex,delUser)) != LB_ERR)
		m_roomUserList.DeleteString(nIndex);
	
}

void CDlgChattingRoom::OnQuitChattingRoom() 
{
	((CChatClientDlg *)parentWnd)->m_pClientSock->sendPacket(C2S_REQ_QUIT_ROOM,"");	
}
